@use crate::features_page::FeaturesPageBorrow;
@use crate::iter::*;
@use crate::limit_text_len_mid;
@use crate::templates::base_html;
@use crate::templates::target_cfg_html;
@use crate::Urler;
@use cargo_toml::features::Kind;
@use kitchen_sink::Target;

@(url: &Urler, c: FeaturesPageBorrow<'_>)

@:base_html(&c.page(), {
  <header id="package" @if c.ver.is_yanked() {class="yanked"}>
    <div class="inner-col">
    <div class="breadcrumbs">
    <h1>
      <a href="/"><span>Lib</span>.rs</a>
    </h1>
     › <a href="@url.crate_by_origin(c.ver.origin())" rel="up">@c.ver.capitalized_name()</a>
     › Features
    </div>
    <nav><ul>
      <li><a href="@url.crate_by_origin(c.ver.origin())">Latest version</a></li>
      <li class=active>Features</li>
      @if let Some(url) = &c.cargo_toml_url {
        <li><a rel="nofollow" href="@url">Cargo.toml</a></li>
      }
      @if let Some(url) = url.reverse_deps(c.ver.origin()) {
        <li><a href="@url">Reverse dependencies</a></li>
      }
    </ul></nav>
    </div>
  </header>
  <main id=deps-features>
    <div class="inner-col">
      @if c.features.is_empty() && c.only_dependencies.is_empty() {
        <p class=empty>@c.ver.capitalized_name() has no @if c.collected.removed_hidden_features {user-facing} Cargo features.</p>
      } else {
      @for (t, title, are_deps_only, preface, html_id) in [
          (&c.features, "Cargo Features", false, &c.collected.preface, None),
          (&c.only_dependencies, "Features from optional dependencies", true, &c.collected.deps_preface, Some("features-dep-implied")),
        ] { @if !t.is_empty() || !preface.is_empty() {
        <h2 @if let Some(id) = html_id {id="@id"}>@title</h2>
        @if are_deps_only {
          @if t.iter().any(|d| !d.f.explicit && d.f.is_referenced()) {
            <p>In crates that don't use <a href="https://doc.rust-lang.org/cargo/reference/features.html#optional-dependencies">the <code>dep:</code> syntax</a>, optional dependencies automatically become Cargo features. These features may have been created by mistake, and this functionality <a href="https://rust-lang.github.io/rfcs/3491-remove-implicit-features.html">may be removed in the future</a>.</p>
          }
        } else {
          @if c.collected.features_enabled_by_default.is_empty() {
            <p>@c.ver.capitalized_name() has no features set by default.</p>
          }

          <pre lang=toml><code><tt class="m-tag m-tag-tbl">[<tt class="ent-tbl ent-tbl-toml">dependencies</tt>]</tt>
<tt class="ent-n ent-n-tag">@c.ver.short_name()</tt> = @{ <tt class="ent-n ent-n-tag">version</tt> = <tt class="str-q str-q-dbl">"@c.ver.version()"</tt>@if !c.collected.features_enabled_by_default.is_empty() {, <tt class="ent-n ent-n-tag">default-features</tt> = <tt class="str-q str-q-dbl">false</tt>}, <tt class="ent-n ent-n-tag">features</tt> = <tt class="m-arr m-arr-toml">[@for (last, f) in c.features.iter().chain(&c.only_dependencies).filter(|f| f.f.explicit || f.f.non_default_enabled_by().next().is_none()).map(|f| f.f.key).filter(|&k| k != "default" && !k.starts_with('_')).identify_last() {<tt class="str-q str-q-dbl">"<a href="#feature-@f">@f</a>"</tt>@if !last {, }}]</tt> @}</tt></tt></code></pre>

        }
        @if !preface.is_empty() {
          <blockquote>@c.render_comment(preface)</blockquote>
        }

        <dl@if c.has_long_keys { class="long"}>
          @for (f, f_dep) in t.iter().map(|f| (f, c.if_is_dep(f))) {
            <dt id="feature-@f.f.key">
                @for m in f.merged_keys.iter() { <b id="feature-@m">@m</b> }
                @if let Some(f_dep) = &f_dep {
                  <a class="package" href="@url.crate_by_origin(&f_dep.origin)"><b@if f.f.key.len()>20 { class="long"}>@f.f.key</b></a>
                } else { <b@if f.f.key.len()>20 { class="long"}>@f.f.key</b> }

                @if f.dep_kind == Kind::Build { <span class="label label-build" title="build-time dep">build</span> }
                @if f.dep_kind == Kind::Dev { <span class="label label-dev" title="only in dev">dev</span> }

                @if let Some(f_dep) = &f_dep {
                  @for t in &f_dep.only_for_targets {
                    @if let Target::Cfg(t) = t {
                      @:target_cfg_html(&t)
                    } else {
                      <span class="feature cfg label-optional" title="platform-specific">@t</span>
                    }
                  }
                }

                @if !f.f.explicit && !f.f.is_referenced() {
                  <span class="feature label-optional">implicit feature</span>
                }

                @if f.f.enabled_by.contains("default") && f.f.key != "default" {
                  <span class="feature label-default" title="use default-features = false">default</span>
                }
                @for (e, enabled) in f.f.non_default_enabled_by().map(|e| (e, c.collected.features_enabled_by_default.contains(e))) {
                  <span title="@e enables @f.f.key" class="feature label-default"><a class="feat-link" href="#feature-@e">@limit_text_len_mid(e, 35)</a>@if !enabled {?}</span>
                }

                @if !f.f.enables_features.is_empty() {
                  <span class="eq">=</span>
                  <span class="feat-links">
                  @for (last, key) in f.f.enables_features.iter().copied().identify_last() {
                    <a class="feat-link" href="#feature-@key">@limit_text_len_mid(key, 35)</a>@if !last {,}
                  }
                  </span>
                }
              </dt>
              <dd>
                @if !f.comment.is_empty() { <blockquote>@c.render_comment(f.comment)</blockquote> } else if f.f.key == "default" && !c.collected.default_feature_is_empty {
                  <p>@if f.f.enables_deps.is_empty() && f.f.enables_features.len()==1 {
                    The <code>@for s in &f.f.enables_features {@s}</code> feature is set <a href="https://doc.rust-lang.org/cargo/reference/features.html#the-default-feature">by default</a>
                  } else {
                    These <a href="https://doc.rust-lang.org/cargo/reference/features.html#the-default-feature">default features</a> are set
                  }
                  whenever <code>@c.ver.short_name()</code> is added without <code><nobr>default-features = false</nobr></code> somewhere in the dependency tree.</p>
                }
                @if let Some((text, actions)) = c.enables_deps_merged(f) {
                  <p>@text
                    @for (list_sep0, action) in actions.iter().comma_list(true) {@if list_sep0 != "" {@if action.show_comment { and } else {,}}
                      @for (list_sep1, ((dep_feature, alt_feature), origin)) in action.all_features().comma_list(false) {@list_sep1
                        <a class="feat-link" href="@url.features(origin, Some(dep_feature))">@limit_text_len_mid(dep_feature, 35)</a>@if let Some(alt_feature) = alt_feature {
                          (@for (last, alt_feature) in alt_feature.iter().identify_last() {<a class="feat-link"
                            href="@url.features(origin, Some(alt_feature))">@limit_text_len_mid(alt_feature, 35)</a>@if !last {,
                          }})} else if dep_feature == "default" { features}}

                        @if !action.hide_deps {
                          @if action.all_features().next().is_some() { of }
                          @for (list_sep, ac) in action.deps.iter().comma_list(true) {@list_sep
                            @if ac.is_conditional { <span class="feature label-optional" title="only if already set">optional</span> }

                            @if let Some(default_feature) = action.an_example_feature().filter(|_| list_sep != "") {
                              <a href="@url.features(&ac.dep.origin, Some(default_feature))" @if !ac.dep.origin.package_name_icase().eq_ignore_ascii_case(ac.key) { title="alias @ac.key" }>}
                            else {
                              <a href="@url.crate_by_origin(&ac.dep.origin)" @if !ac.dep.origin.package_name_icase().eq_ignore_ascii_case(ac.key) { title="alias @ac.key" }>}@ac.dep.origin.package_name_icase()@if let Some(not_latest) = &ac.dep.not_latest {
                              <strong class="outdated">@not_latest</strong>}</a>}@if let Some((dep_comment, show_crate_name)) = action.dep_comment() {
                                </p><blockquote>@if let Some(cn) = show_crate_name {<small>@cn:</small> }@c.render_comment(dep_comment)</blockquote><p>
                              }}}
                  </p>
                }
                @if !f.items_enabled_by_feature.is_empty() {
                  <p>Affects @for (last, i) in f.items_enabled_by_feature.iter().take(20).identify_last() {
                    <code>@i</code>@if !last {,} else {…}
                  }
                  </p>
                }
                @if !f.f.required_by_bins.is_empty() {
                  <p>Required by @if f.f.required_by_bins.len()==1 {the} @for (sep, name) in f.f.required_by_bins.iter().comma_list(false) {@sep @name} @if f.f.required_by_bins.len()==1 {binary} else {binaries}</p>
                }
              </dd>
          }
          </dl>
        }
        @if !are_deps_only && c.all_features_are_boring > 0 {
          <p>@c.ver.capitalized_name() has @c.all_features_are_boring feature@if c.all_features_are_boring!=1 {s} without comment@if c.all_features_are_boring!=1 {s}.</p>
        }
      } }
    </div>
  </main>

  <footer>
    <div class="inner-col">
        <p>The data is based on the crate's @if let Some(url) = &c.cargo_toml_url {<a rel="nofollow" href="@url">Cargo.toml</a>} else {Cargo.toml},
          including TOML comments@if c.all_features_are_boring > 0 { (if present)}. @if c.collected.has_items_enabled_by_features {
          Affected code identifiers are only an approximation and a sample.
        }
        @if c.collected.removed_hidden_features { Features starting with underscore were inlined and hidden. }
        @if c.features.iter().any(|f| !f.merged_keys.is_empty()) { Multiple features listed on one line are only for compact screen layout. }
        </p>
        <p>Back to <a href="@url.crate_by_origin(c.ver.origin())" rel="up">@c.ver.capitalized_name()</a>.</p>
    </div>
  </footer>
})
